/* 
   Example of using C++ with the PLI and VCS 
   Creates a simple class with a static variable
   This is then used in calltf routine
*/

#include <iostream.h>
#include "veriuser.h"

/* Define a class with a static variable */
class Sc {
public:
  Sc(int id);
  ~Sc();
  int GetStatic() const {return sint;}
  void SetStatic(int val) {sint = val;}
  int sc_id;

private:
  static int sint;
}; // class Sc

int Sc::sint = 1;

Sc::Sc(int id)
{
  cout << "Sc constructor called id = " << id << endl;
  sc_id = id;
}
Sc::~Sc()
{
  cout << "Sc destructor called for id = " << sc_id << endl;
}

Sc sc0(0);
Sc *sc1,*sc2;


/* This is the C++ routine to construct the objects */
void hello_cpp_check (int data, int reason)
{
  static int initialized = 0;

  if (!initialized) {
    sc1 = new Sc(1);
    sc2 = new Sc(2);
    initialized = 1;
  }
} //  hello_cpp_check
#ifdef __cplusplus
extern "C" 
#endif
void hello_check(int data, int reason)
{
  hello_cpp_check(data, reason);
}


/* This is a C++ routine to do the calltf work */
void hello_cpp_call(int data, int reason)
{
  Sc sc3(3);

  cout << "$hello task called with the value " <<
    tf_getp(1) << "\n";

  cout << "sc1.sint = " << sc1->GetStatic() << "\n";
  cout << "Setting static = 55\n";
  sc1->SetStatic(55);
  cout << "sc1.sint = " << sc1->GetStatic() << "\n";
  cout << "sc2.sint = " << sc2->GetStatic() << "\n";
}


/* This is the C routine called by VCS, which then calls
   the C++ routine to do the real work */
#ifdef __cplusplus
extern "C" 
#endif
void hello_call(int data, int reason)
{
  hello_cpp_call(data, reason);
}
